﻿package {
	
	import flash.display.MovieClip;
	
	import gs.TweenLite;
	import flash.net.URLRequest;
	import flash.events.*;
	import flash.net.*;
	import flash.display.Loader;
	import flash.utils.Timer;
	import fl.motion.easing.*;
	import flash.utils.Timer;

	public class updates_class extends MovieClip {
	
	private var ledDots,ledMask,ledMask2,ledText,ledBg,ledEndcaps,ledLogo,updates,counter,timer,oldY,nextRefresh,refreshTimer,data_source;
		
		public function updates_class()
		{
			ledDots=new led_dots();
			ledMask=new led_mask();
			ledMask2=new led_mask();
			ledText=new led_text();
			
			ledBg=new led_bg();
			ledEndcaps=new led_endcaps();
			setup();
		}
		
		private function setup()
		{
			
			this.x=20;
			this.y=10;

			this.addChild(ledBg);

			this.addChild(ledDots);
			ledDots.x=45;
			this.addChild(ledText);
			ledText.x=45;
			
			
			this.addChild(ledMask);
			ledMask.x=45;
			this.addChild(ledMask2);
			ledMask2.x=45;
			//ledMask2.addEventListener(MouseEvent.CLICK,onClick);
			ledDots.mask=ledMask2;
			ledText.mask=ledMask;
			oldY=ledText.y;
			
			counter=0;
			loadSetupXML();
			
		}
		private function onClick(e)
		{
			
		}
		private function scrollText()
		{
			
			var timeReq=ledText.width/ledMask.width*5+2;

			var destX=ledText.width+ledMask.width;
			destX="-"+destX;
			
			
		}
		private function scrollNext(e)
		{
			trace(" at counter ",counter);
			if(counter>=updates.length)
			{
				counter=0;
			}
			TweenLite.to(ledText,0.5,{alpha:0,y:"-50",onComplete:onTextDisappearComplete});
			
			
		}
		public function onTextDisappearComplete()
		{
			ledText.alpha=0;
			ledText.y=oldY+50;
			TweenLite.to(ledText,0.5,{alpha:1,y:oldY});
			ledText.scrollingText.htmlText=updates[counter].title+": "+updates[counter].body;
			ledText.scrollingText.autoSize="left";
			counter++;
			scrollText();
		}
		public function loadXML(){
			trace("loading xml again");
			var url="";
			var urlReq=new URLRequest(url+data_source); // use Math.randomInt() if caching is a problem
			var urlLoad=new URLLoader();
			urlLoad.addEventListener(Event.COMPLETE,onComplete);
			urlLoad.load(urlReq);
			
			
		}
		private function onComplete(e)
		{
			if(e.target.data.length>0)
			{
				
				trace(e.target.data)	;
				var xml=new XML(e.target.data);
				
			if(timer.delay)
			timer.start();
			trace ("timer delay is ",timer.delay);
			
			if(refreshTimer.delay)
			refreshTimer.start();
			
			
				trace("xml length",xml.elements("update").length());
				updates=new Array();
				
				for(var i=0;i<xml.elements("update").length();i++)
				{
					updates[i]={title:xml.update[i].title,body:xml.update[i].body};
				}
				
			
			//trace("updates array ",updates.toString());
			scrollNext(new Event("test"));
			}
			
		}
		public function loadSetupXML(){
			var url="";
			var urlReq=new URLRequest(url+"updates_setup.xml");
			var urlLoad=new URLLoader();
			if(timer is Timer)
			{
				timer.removeEventListener("timer",scrollNext);
			}
			if(refreshTimer is Timer)
			refreshTimer.removeEventListener("timer",refreshNow);
			
			urlLoad.addEventListener(Event.COMPLETE,onSetupLoadComplete);
			urlLoad.load(urlReq);
			
			
		}
		private function onSetupLoadComplete(e)
		{
			if(e.target.data.length>0)
			{
				
				trace(e.target.data)	;
				var xml=new XML(e.target.data);
				
				nextRefresh=parseInt(xml.reload_source_delay);
				trace("next change after ", xml.delay);

				timer=new Timer(parseInt(xml.next_update_delay)*1000);
				ledBg.logo.title.text=xml.title;
				data_source=xml.data_source;
			timer.addEventListener("timer",scrollNext);
			
			trace(" nextrefresh in ", nextRefresh);
			refreshTimer=new Timer(nextRefresh*1000,1);
			refreshTimer.addEventListener("timer",refreshNow);
			
			
			loadXML();
				
			}
			
		}
		private function refreshNow(e)
		{
			trace("refreshing ");
			
			loadXML();
	}
		
	}
}